/[gentoo-x86]/eclass/kernel-2.eclass
Gentoo

Contents of /eclass/kernel-2.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.281 - (hide annotations) (download)
Wed Mar 20 16:45:56 2013 UTC (6 years, 2 months ago) by tomwij
Branch: MAIN
Changes since 1.280: +3 -3 lines
Use UID 0 instead of root to assign permissions to super user, bug #315807.

1 mpagano 1.278 # Copyright 1999-2013 Gentoo Foundation
2 johnm 1.13 # Distributed under the terms of the GNU General Public License v2
3 tomwij 1.281 # $Header: /var/cvsroot/gentoo-x86/eclass/kernel-2.eclass,v 1.280 2013/03/20 07:55:54 tomwij Exp $
4 johnm 1.13
5 johnm 1.54 # Description: kernel.eclass rewrite for a clean base regarding the 2.6
6     # series of kernel with back-compatibility for 2.4
7 johnm 1.3 #
8 phreak 1.206 # Original author: John Mylchreest <johnm@gentoo.org>
9     # Maintainer: kernel-misc@gentoo.org
10 johnm 1.3 #
11     # Please direct your bugs to the current eclass maintainer :)
12 johnm 1.1
13     # added functionality:
14     # unipatch - a flexible, singular method to extract, add and remove patches.
15    
16 johnm 1.54 # A Couple of env vars are available to effect usage of this eclass
17 johnm 1.1 # These are as follows:
18     #
19 johnm 1.93 # K_USEPV - When setting the EXTRAVERSION variable, it should
20     # add PV to the end.
21     # this is useful for thigns like wolk. IE:
22     # EXTRAVERSION would be something like : -wolk-4.19-r1
23 johnm 1.55 # K_NOSETEXTRAVERSION - if this is set then EXTRAVERSION will not be
24     # automatically set within the kernel Makefile
25     # K_NOUSENAME - if this is set then EXTRAVERSION will not include the
26     # first part of ${PN} in EXTRAVERSION
27 robbat2 1.163 # K_NOUSEPR - if this is set then EXTRAVERSION will not include the
28     # anything based on ${PR}.
29 lu_zero 1.62 # K_PREPATCHED - if the patchset is prepatched (ie: mm-sources,
30     # ck-sources, ac-sources) it will use PR (ie: -r5) as
31     # the patchset version for
32 johnm 1.93 # and not use it as a true package revision
33 johnm 1.55 # K_EXTRAEINFO - this is a new-line seperated list of einfo displays in
34 lu_zero 1.62 # postinst and can be used to carry additional postinst
35 johnm 1.55 # messages
36 zlin 1.208 # K_EXTRAELOG - same as K_EXTRAEINFO except using elog instead of einfo
37     # K_EXTRAEWARN - same as K_EXTRAEINFO except using ewarn instead of einfo
38 johnm 1.107 # K_SYMLINK - if this is set, then forcably create symlink anyway
39 plasmaroo 1.105 #
40 johnm 1.108 # K_DEFCONFIG - Allow specifying a different defconfig target.
41     # If length zero, defaults to "defconfig".
42 dsd 1.126 # K_WANT_GENPATCHES - Apply genpatches to kernel source. Provide any
43     # combination of "base" and "extras"
44     # K_GENPATCHES_VER - The version of the genpatches tarball(s) to apply.
45     # A value of "5" would apply genpatches-2.6.12-5 to
46     # my-sources-2.6.12.ebuild
47 dsd 1.200 # K_SECURITY_UNSUPPORTED- If set, this kernel is unsupported by Gentoo Security
48 robbat2 1.230 # K_DEBLOB_AVAILABLE - A value of "0" will disable all of the optional deblob
49     # code. If empty, will be set to "1" if deblobbing is
50     # possible. Test ONLY for "1".
51     # K_PREDEBLOBBED - This kernel was already deblobbed elsewhere.
52     # If false, either optional deblobbing will be available
53     # or the license will note the inclusion of freedist
54     # code.
55 mpagano 1.244 # K_LONGTERM - If set, the eclass will search for the kernel source
56 ulm 1.249 # in the long term directories on the upstream servers
57 mpagano 1.244 # as the location has been changed by upstream
58 johnm 1.55 # H_SUPPORTEDARCH - this should be a space separated list of ARCH's which
59     # can be supported by the headers ebuild
60    
61     # UNIPATCH_LIST - space delimetered list of patches to be applied to the
62     # kernel
63     # UNIPATCH_EXCLUDE - an addition var to support exlusion based completely
64     # on "<passedstring>*" and not "<passedno#>_*"
65 lu_zero 1.62 # - this should _NOT_ be used from the ebuild as this is
66 johnm 1.55 # reserved for end users passing excludes from the cli
67 lu_zero 1.62 # UNIPATCH_DOCS - space delimemeted list of docs to be installed to
68 johnm 1.55 # the doc dir
69 lu_zero 1.62 # UNIPATCH_STRICTORDER - if this is set places patches into directories of
70 johnm 1.55 # order, so they are applied in the order passed
71 johnm 1.1
72 phreak 1.192 inherit eutils toolchain-funcs versionator multilib
73 mpagano 1.256 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_preinst pkg_postinst pkg_postrm
74 johnm 1.1
75 dostrow 1.132 # Added by Daniel Ostrow <dostrow@gentoo.org>
76     # This is an ugly hack to get around an issue with a 32-bit userland on ppc64.
77     # I will remove it when I come up with something more reasonable.
78 vapier 1.189 [[ ${PROFILE_ARCH} == "ppc64" ]] && CHOST="powerpc64-${CHOST#*-}"
79 dostrow 1.132
80 vapier 1.75 export CTARGET=${CTARGET:-${CHOST}}
81 hollow 1.96 if [[ ${CTARGET} == ${CHOST} && ${CATEGORY/cross-} != ${CATEGORY} ]]; then
82 hollow 1.95 export CTARGET=${CATEGORY/cross-}
83 vapier 1.75 fi
84 vapier 1.60
85 phreak 1.181 HOMEPAGE="http://www.kernel.org/ http://www.gentoo.org/ ${HOMEPAGE}"
86 vapier 1.267 : ${LICENSE:="GPL-2"}
87 johnm 1.1
88 robbat2 1.231 # This is the latest KV_PATCH of the deblob tool available from the
89 robbat2 1.243 # libre-sources upstream. If you bump this, you MUST regenerate the Manifests
90     # for ALL kernel-2 consumer packages where deblob is available.
91 vapier 1.267 : ${DEBLOB_MAX_VERSION:=38}
92 robbat2 1.231
93 brix 1.178 # No need to run scanelf/strip on kernel sources/headers (bug #134453).
94     RESTRICT="binchecks strip"
95    
96 johnm 1.18 # set LINUX_HOSTCFLAGS if not already set
97 vapier 1.267 : ${LINUX_HOSTCFLAGS:="-Wall -Wstrict-prototypes -Os -fomit-frame-pointer -I${S}/include"}
98 johnm 1.18
99 robbat2 1.163 # debugging functions
100     #==============================================================
101     # this function exists only to help debug kernel-2.eclass
102     # if you are adding new functionality in, put a call to it
103     # at the start of src_unpack, or during SRC_URI/dep generation.
104     debug-print-kernel2-variables() {
105 robbat2 1.228 for v in PVR CKV OKV KV KV_FULL KV_MAJOR KV_MINOR KV_PATCH RELEASETYPE \
106     RELEASE UNIPATCH_LIST_DEFAULT UNIPATCH_LIST_GENPATCHES \
107 mpagano 1.259 UNIPATCH_LIST S KERNEL_URI K_WANT_GENPATCHES ; do
108 robbat2 1.228 debug-print "${v}: ${!v}"
109     done
110 robbat2 1.163 }
111    
112 johnm 1.54 #Eclass functions only from here onwards ...
113 plasmaroo 1.33 #==============================================================
114 dsd 1.126 handle_genpatches() {
115     local tarball
116 vapier 1.218 [[ -z ${K_WANT_GENPATCHES} || -z ${K_GENPATCHES_VER} ]] && return 1
117 dsd 1.126
118 mpagano 1.254 debug-print "Inside handle_genpatches"
119 vapier 1.266 local OKV_ARRAY
120     IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
121 mpagano 1.254
122     # for > 3.0 kernels, handle genpatches tarball name
123     # genpatches for 3.0 and 3.0.1 might be named
124 tomwij 1.279 # genpatches-3.0-1.base.tar.xz and genpatches-3.0-2.base.tar.xz
125 mpagano 1.254 # respectively. Handle this.
126    
127 dsd 1.126 for i in ${K_WANT_GENPATCHES} ; do
128 mpagano 1.254 if [[ ${KV_MAJOR} -ge 3 ]]; then
129     if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
130 tomwij 1.279 tarball="genpatches-${KV_MAJOR}.${KV_MINOR}-${K_GENPATCHES_VER}.${i}.tar.xz"
131 mpagano 1.254 else
132 tomwij 1.279 tarball="genpatches-${KV_MAJOR}.${KV_PATCH}-${K_GENPATCHES_VER}.${i}.tar.xz"
133 mpagano 1.254 fi
134     else
135 tomwij 1.279 tarball="genpatches-${OKV}-${K_GENPATCHES_VER}.${i}.tar.xz"
136 mpagano 1.254 fi
137     debug-print "genpatches tarball: $tarball"
138     GENPATCHES_URI="${GENPATCHES_URI} mirror://gentoo/${tarball}"
139     UNIPATCH_LIST_GENPATCHES="${UNIPATCH_LIST_GENPATCHES} ${DISTDIR}/${tarball}"
140 dsd 1.126 done
141     }
142    
143 johnm 1.117 detect_version() {
144     # this function will detect and set
145     # - OKV: Original Kernel Version (2.6.0/2.6.0-test11)
146     # - KV: Kernel Version (2.6.0-gentoo/2.6.0-test11-gentoo-r1)
147     # - EXTRAVERSION: The additional version appended to OKV (-gentoo/-gentoo-r1)
148    
149 vapier 1.272 # We've already run, so nothing to do here.
150     [[ -n ${KV_FULL} ]] && return 0
151 johnm 1.117
152     # CKV is used as a comparison kernel version, which is used when
153     # PV doesnt reflect the genuine kernel version.
154     # this gets set to the portage style versioning. ie:
155     # CKV=2.6.11_rc4
156     CKV=${CKV:-${PV}}
157     OKV=${OKV:-${CKV}}
158     OKV=${OKV/_beta/-test}
159     OKV=${OKV/_rc/-rc}
160     OKV=${OKV/-r*}
161     OKV=${OKV/_p*}
162    
163     KV_MAJOR=$(get_version_component_range 1 ${OKV})
164 mpagano 1.254 # handle if OKV is X.Y or X.Y.Z (e.g. 3.0 or 3.0.1)
165 vapier 1.266 local OKV_ARRAY
166     IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
167 johnm 1.117
168 mpagano 1.252 # if KV_MAJOR >= 3, then we have no more KV_MINOR
169 mpagano 1.254 #if [[ ${KV_MAJOR} -lt 3 ]]; then
170     if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
171 mpagano 1.253 KV_MINOR=$(get_version_component_range 2 ${OKV})
172 mpagano 1.252 KV_PATCH=$(get_version_component_range 3 ${OKV})
173     if [[ ${KV_MAJOR}${KV_MINOR}${KV_PATCH} -ge 269 ]]; then
174     KV_EXTRA=$(get_version_component_range 4- ${OKV})
175     KV_EXTRA=${KV_EXTRA/[-_]*}
176     else
177     KV_PATCH=$(get_version_component_range 3- ${OKV})
178     fi
179     else
180     KV_PATCH=$(get_version_component_range 2 ${OKV})
181     KV_EXTRA=$(get_version_component_range 3- ${OKV})
182 johnm 1.117 KV_EXTRA=${KV_EXTRA/[-_]*}
183     fi
184 mpagano 1.252
185 mpagano 1.254 debug-print "KV_EXTRA is ${KV_EXTRA}"
186    
187 johnm 1.117 KV_PATCH=${KV_PATCH/[-_]*}
188 ulm 1.249
189 robbat2 1.234 local v n=0 missing
190 mpagano 1.254 #if [[ ${KV_MAJOR} -lt 3 ]]; then
191     if [[ ${#OKV_ARRAY[@]} -ge 3 ]]; then
192 mpagano 1.252 for v in CKV OKV KV_{MAJOR,MINOR,PATCH} ; do
193     [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
194     done
195     else
196     for v in CKV OKV KV_{MAJOR,PATCH} ; do
197     [[ -z ${!v} ]] && n=1 && missing="${missing}${v} ";
198     done
199     fi
200    
201 robbat2 1.234 [[ $n -eq 1 ]] && \
202     eerror "Missing variables: ${missing}" && \
203 ulm 1.249 die "Failed to extract kernel version (try explicit CKV in ebuild)!"
204 robbat2 1.234 unset v n missing
205 johnm 1.117
206 mpagano 1.254 # if [[ ${KV_MAJOR} -ge 3 ]]; then
207     if [[ ${#OKV_ARRAY[@]} -lt 3 ]]; then
208 mpagano 1.252 KV_PATCH_ARR=(${KV_PATCH//\./ })
209 mpagano 1.254
210 mpagano 1.275 # at this point 031412, Linus is putting all 3.x kernels in a
211     # 3.x directory, may need to revisit when 4.x is released
212     KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.x"
213    
214 mpagano 1.252 [[ -n "${K_LONGTERM}" ]] &&
215     KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_PATCH_ARR}"
216     else
217 mpagano 1.257 #KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.0"
218 mpagano 1.261 #KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}"
219 mpagano 1.262 if [[ ${KV_MAJOR} -ge 3 ]]; then
220     KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.x"
221     else
222     KERNEL_BASE_URI="mirror://kernel/linux/kernel/v${KV_MAJOR}.${KV_MINOR}"
223     fi
224    
225 mpagano 1.252 [[ -n "${K_LONGTERM}" ]] &&
226 psomas 1.274 #KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm"
227     KERNEL_BASE_URI="${KERNEL_BASE_URI}/longterm/v${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
228 mpagano 1.252 fi
229 mpagano 1.244
230 mpagano 1.257 debug-print "KERNEL_BASE_URI is ${KERNEL_BASE_URI}"
231    
232 mpagano 1.254 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
233 mpagano 1.259 # handle non genpatch using sources correctly
234     if [[ -z ${K_WANT_GENPATCHES} && -z ${K_GENPATCHES_VER} && ${KV_PATCH} -gt 0 ]]; then
235 tomwij 1.279 KERNEL_URI="${KERNEL_BASE_URI}/patch-${OKV}.xz"
236     UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.xz"
237 mpagano 1.254 fi
238 tomwij 1.279 KERNEL_URI="${KERNEL_URI} ${KERNEL_BASE_URI}/linux-${KV_MAJOR}.${KV_MINOR}.tar.xz"
239 mpagano 1.254 else
240 tomwij 1.279 KERNEL_URI="${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
241 mpagano 1.254 fi
242 johnm 1.117
243     RELEASE=${CKV/${OKV}}
244     RELEASE=${RELEASE/_beta}
245     RELEASE=${RELEASE/_rc/-rc}
246     RELEASE=${RELEASE/_pre/-pre}
247 robbat2 1.234 # We cannot trivally call kernel_is here, because it calls us to detect the
248     # version
249     #kernel_is ge 2 6 && RELEASE=${RELEASE/-pre/-git}
250 mpagano 1.252 [ $(($KV_MAJOR * 1000 + ${KV_MINOR:-0})) -ge 2006 ] && RELEASE=${RELEASE/-pre/-git}
251 johnm 1.117 RELEASETYPE=${RELEASE//[0-9]}
252    
253 gregkh 1.156 # Now we know that RELEASE is the -rc/-git
254 johnm 1.117 # and RELEASETYPE is the same but with its numerics stripped
255     # we can work on better sorting EXTRAVERSION.
256     # first of all, we add the release
257     EXTRAVERSION="${RELEASE}"
258 robbat2 1.163 debug-print "0 EXTRAVERSION:${EXTRAVERSION}"
259 mpagano 1.254 [[ -n ${KV_EXTRA} ]] && [[ ${KV_MAJOR} -lt 3 ]] && EXTRAVERSION=".${KV_EXTRA}${EXTRAVERSION}"
260 johnm 1.117
261 robbat2 1.163 debug-print "1 EXTRAVERSION:${EXTRAVERSION}"
262     if [[ -n "${K_NOUSEPR}" ]]; then
263     # Don't add anything based on PR to EXTRAVERSION
264     debug-print "1.0 EXTRAVERSION:${EXTRAVERSION}"
265     elif [[ -n ${K_PREPATCHED} ]]; then
266     debug-print "1.1 EXTRAVERSION:${EXTRAVERSION}"
267 johnm 1.117 EXTRAVERSION="${EXTRAVERSION}-${PN/-*}${PR/r}"
268     elif [[ "${ETYPE}" = "sources" ]]; then
269 robbat2 1.163 debug-print "1.2 EXTRAVERSION:${EXTRAVERSION}"
270 johnm 1.117 # For some sources we want to use the PV in the extra version
271     # This is because upstream releases with a completely different
272     # versioning scheme.
273     case ${PN/-*} in
274     wolk) K_USEPV=1;;
275     vserver) K_USEPV=1;;
276     esac
277    
278 robbat2 1.163 [[ -z "${K_NOUSENAME}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PN/-*}"
279     [[ -n "${K_USEPV}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PV//_/-}"
280     [[ -n "${PR//r0}" ]] && EXTRAVERSION="${EXTRAVERSION}-${PR}"
281 johnm 1.117 fi
282 robbat2 1.163 debug-print "2 EXTRAVERSION:${EXTRAVERSION}"
283 johnm 1.117
284 johnm 1.120 # The only messing around which should actually effect this is for KV_EXTRA
285     # since this has to limit OKV to MAJ.MIN.PAT and strip EXTRA off else
286     # KV_FULL evaluates to MAJ.MIN.PAT.EXT.EXT after EXTRAVERSION
287 mpagano 1.252
288 johnm 1.120 if [[ -n ${KV_EXTRA} ]]; then
289 mpagano 1.252 if [[ -n ${KV_MINOR} ]]; then
290     OKV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
291     else
292     OKV="${KV_MAJOR}.${KV_PATCH}"
293     fi
294 tomwij 1.279 KERNEL_URI="${KERNEL_BASE_URI}/patch-${CKV}.xz
295     ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
296     UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV}.xz"
297 johnm 1.120 fi
298 swegener 1.135
299 johnm 1.118 # We need to set this using OKV, but we need to set it before we do any
300     # messing around with OKV based on RELEASETYPE
301     KV_FULL=${OKV}${EXTRAVERSION}
302    
303     # we will set this for backwards compatibility.
304     S=${WORKDIR}/linux-${KV_FULL}
305     KV=${KV_FULL}
306    
307 gregkh 1.156 # -rc-git pulls can be achieved by specifying CKV
308 johnm 1.117 # for example:
309     # CKV="2.6.11_rc3_pre2"
310     # will pull:
311 tomwij 1.279 # linux-2.6.10.tar.xz & patch-2.6.11-rc3.xz & patch-2.6.11-rc3-git2.xz
312 johnm 1.117
313 mpagano 1.252 if [[ ${KV_MAJOR}${KV_MINOR} -eq 26 ]]; then
314    
315     if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
316     OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
317 tomwij 1.279 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.xz
318     ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
319     UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.xz"
320 mpagano 1.252 fi
321    
322     if [[ ${RELEASETYPE} == -git ]]; then
323 tomwij 1.279 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.xz
324     ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
325     UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.xz"
326 mpagano 1.252 fi
327    
328     if [[ ${RELEASETYPE} == -rc-git ]]; then
329     OKV="${KV_MAJOR}.${KV_MINOR}.$((${KV_PATCH} - 1))"
330 tomwij 1.279 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.xz
331     ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.xz
332     ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
333 mpagano 1.252
334 tomwij 1.279 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE/-git*}.xz ${DISTDIR}/patch-${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${RELEASE}.xz"
335 mpagano 1.252 fi
336     else
337     if [[ ${RELEASETYPE} == -rc ]] || [[ ${RELEASETYPE} == -pre ]]; then
338     if [[ ${KV_MAJOR}${KV_PATCH} -eq 30 ]]; then
339     OKV="2.6.39"
340     else
341     KV_PATCH_ARR=(${KV_PATCH//\./ })
342     OKV="${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))"
343     fi
344 tomwij 1.279 KERNEL_URI="${KERNEL_BASE_URI}/testing/patch-${CKV//_/-}.xz
345     ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
346     UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${CKV//_/-}.xz"
347 mpagano 1.252 fi
348    
349     if [[ ${RELEASETYPE} == -git ]]; then
350 tomwij 1.279 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${OKV}${RELEASE}.xz
351     ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
352     UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${OKV}${RELEASE}.xz"
353 mpagano 1.252 fi
354    
355     if [[ ${RELEASETYPE} == -rc-git ]]; then
356     if [[ ${KV_MAJOR}${KV_PATCH} -eq 30 ]]; then
357     OKV="2.6.39"
358     else
359     KV_PATCH_ARR=(${KV_PATCH//\./ })
360     OKV="${KV_MAJOR}.$((${KV_PATCH_ARR} - 1))"
361     fi
362 tomwij 1.279 KERNEL_URI="${KERNEL_BASE_URI}/snapshots/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.xz
363     ${KERNEL_BASE_URI}/testing/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.xz
364     ${KERNEL_BASE_URI}/linux-${OKV}.tar.xz"
365 johnm 1.117
366 tomwij 1.279 UNIPATCH_LIST_DEFAULT="${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE/-git*}.xz ${DISTDIR}/patch-${KV_MAJOR}.${KV_PATCH}${RELEASE}.xz"
367 mpagano 1.252 fi
368 johnm 1.117
369 mpagano 1.244
370 johnm 1.117 fi
371 dsd 1.126
372 mpagano 1.252
373 swegener 1.165 debug-print-kernel2-variables
374 robbat2 1.163
375 dsd 1.126 handle_genpatches
376 johnm 1.117 }
377    
378 vapier 1.273 # Note: duplicated in linux-info.eclass
379 plasmaroo 1.33 kernel_is() {
380 robbat2 1.226 # ALL of these should be set before we can safely continue this function.
381     # some of the sources have in the past had only one set.
382     local v n=0
383     for v in OKV KV_{MAJOR,MINOR,PATCH} ; do [[ -z ${!v} ]] && n=1 ; done
384     [[ $n -eq 1 ]] && detect_version
385     unset v n
386    
387     # Now we can continue
388 vapier 1.269 local operator test value
389 johnm 1.67
390 vapier 1.273 case ${1#-} in
391 johnm 1.93 lt) operator="-lt"; shift;;
392     gt) operator="-gt"; shift;;
393     le) operator="-le"; shift;;
394     ge) operator="-ge"; shift;;
395     eq) operator="-eq"; shift;;
396     *) operator="-eq";;
397     esac
398 vapier 1.269 [[ $# -gt 3 ]] && die "Error in kernel-2_kernel_is(): too many parameters"
399 johnm 1.93
400 vapier 1.270 : $(( test = (KV_MAJOR << 16) + (KV_MINOR << 8) + KV_PATCH ))
401     : $(( value = (${1:-${KV_MAJOR}} << 16) + (${2:-${KV_MINOR}} << 8) + ${3:-${KV_PATCH}} ))
402 vapier 1.269 [ ${test} ${operator} ${value} ]
403 plasmaroo 1.33 }
404 johnm 1.18
405     kernel_is_2_4() {
406 johnm 1.56 kernel_is 2 4
407 johnm 1.18 }
408    
409     kernel_is_2_6() {
410 johnm 1.78 kernel_is 2 6 || kernel_is 2 5
411 johnm 1.18 }
412    
413 plasmaroo 1.33 # Capture the sources type and set DEPENDs
414 hollow 1.95 if [[ ${ETYPE} == sources ]]; then
415 johnm 1.1 DEPEND="!build? ( sys-apps/sed
416 dsd 1.183 >=sys-devel/binutils-2.11.90.0.31 )"
417 johnm 1.147 RDEPEND="!build? ( >=sys-libs/ncurses-5.2
418 mpagano 1.277 sys-devel/make
419 tomwij 1.280 dev-lang/perl
420     sys-devel/bc )"
421 robbat2 1.222 PDEPEND="!build? ( virtual/dev-manager )"
422 lu_zero 1.62
423 johnm 1.72 SLOT="${PVR}"
424 mpagano 1.252 DESCRIPTION="Sources for the ${KV_MAJOR}.${KV_MINOR:-$KV_PATCH} linux kernel"
425 dsd 1.183 IUSE="symlink build"
426 robbat2 1.229
427     # Bug #266157, deblob for libre support
428 robbat2 1.230 if [[ -z ${K_PREDEBLOBBED} ]] ; then
429 mpagano 1.250 # Bug #359865, force a call to detect_version if needed
430     kernel_is ge 2 6 27 && \
431     [[ -z "${K_DEBLOB_AVAILABLE}" ]] && \
432 robbat2 1.231 kernel_is le 2 6 ${DEBLOB_MAX_VERSION} && \
433 mpagano 1.250 K_DEBLOB_AVAILABLE=1
434 robbat2 1.231 if [[ ${K_DEBLOB_AVAILABLE} == "1" ]] ; then
435 robbat2 1.229 IUSE="${IUSE} deblob"
436     # Reflect that kernels contain firmware blobs unless otherwise
437     # stripped
438     LICENSE="${LICENSE} !deblob? ( freedist )"
439    
440 mpagano 1.252 if [[ -n KV_MINOR ]]; then
441     DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}"
442     else
443     DEBLOB_PV="${KV_MAJOR}.${KV_PATCH}"
444     fi
445    
446 mpagano 1.255 if [[ ${KV_MAJOR} -ge 3 ]]; then
447     DEBLOB_PV="${KV_MAJOR}.${KV_MINOR}"
448     fi
449    
450 robbat2 1.229 DEBLOB_A="deblob-${DEBLOB_PV}"
451 robbat2 1.239 DEBLOB_CHECK_A="deblob-check-${DEBLOB_PV}"
452 robbat2 1.229 DEBLOB_HOMEPAGE="http://www.fsfla.org/svnwiki/selibre/linux-libre/"
453 robbat2 1.239 DEBLOB_URI_PATH="download/releases/LATEST-${DEBLOB_PV}.N"
454     if ! has "${EAPI:-0}" 0 1 ; then
455     DEBLOB_CHECK_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/deblob-check -> ${DEBLOB_CHECK_A}"
456     else
457     DEBLOB_CHECK_URI="mirror://gentoo/${DEBLOB_CHECK_A}"
458     fi
459     DEBLOB_URI="${DEBLOB_HOMEPAGE}/${DEBLOB_URI_PATH}/${DEBLOB_A}"
460 robbat2 1.229 HOMEPAGE="${HOMEPAGE} ${DEBLOB_HOMEPAGE}"
461 ulm 1.249
462 mpagano 1.278 DEPEND+=" deblob? ( =dev-lang/python-2* )"
463 robbat2 1.229 KERNEL_URI="${KERNEL_URI}
464     deblob? (
465 robbat2 1.239 ${DEBLOB_URI}
466     ${DEBLOB_CHECK_URI}
467 robbat2 1.229 )"
468     else
469     # We have no way to deblob older kernels, so just mark them as
470     # tainted with non-libre materials.
471     LICENSE="${LICENSE} freedist"
472     fi
473     fi
474    
475 hollow 1.95 elif [[ ${ETYPE} == headers ]]; then
476 johnm 1.72 DESCRIPTION="Linux system headers"
477 swegener 1.135
478 johnm 1.174 # Since we should NOT honour KBUILD_OUTPUT in headers
479     # lets unset it here.
480     unset KBUILD_OUTPUT
481    
482 vapier 1.265 SLOT="0"
483 johnm 1.1 else
484 johnm 1.55 eerror "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
485 johnm 1.93 die "Unknown ETYPE=\"${ETYPE}\", must be \"sources\" or \"headers\""
486 johnm 1.1 fi
487    
488 vapier 1.153 # Cross-compile support functions
489 johnm 1.1 #==============================================================
490 vapier 1.153 kernel_header_destdir() {
491     [[ ${CTARGET} == ${CHOST} ]] \
492     && echo /usr/include \
493 vapier 1.168 || echo /usr/${CTARGET}/usr/include
494 vapier 1.153 }
495    
496     cross_pre_c_headers() {
497 kugelfang 1.187 use crosscompile_opts_headers-only && [[ ${CHOST} != ${CTARGET} ]]
498 vapier 1.153 }
499    
500     env_setup_xmakeopts() {
501 johnm 1.117 # Kernel ARCH != portage ARCH
502 vapier 1.153 export KARCH=$(tc-arch-kernel)
503 johnm 1.117
504 vapier 1.136 # When cross-compiling, we need to set the ARCH/CROSS_COMPILE
505     # variables properly or bad things happen !
506 vapier 1.153 xmakeopts="ARCH=${KARCH}"
507     if [[ ${CTARGET} != ${CHOST} ]] && ! cross_pre_c_headers ; then
508 vapier 1.136 xmakeopts="${xmakeopts} CROSS_COMPILE=${CTARGET}-"
509 vapier 1.151 elif type -p ${CHOST}-ar > /dev/null ; then
510 vapier 1.136 xmakeopts="${xmakeopts} CROSS_COMPILE=${CHOST}-"
511     fi
512 vapier 1.153 export xmakeopts
513     }
514    
515     # Unpack functions
516     #==============================================================
517     unpack_2_4() {
518 lu_zero 1.62 # this file is required for other things to build properly,
519 johnm 1.1 # so we autogenerate it
520 vapier 1.145 make -s mrproper ${xmakeopts} || die "make mrproper failed"
521     make -s symlinks ${xmakeopts} || die "make symlinks failed"
522     make -s include/linux/version.h ${xmakeopts} || die "make include/linux/version.h failed"
523 johnm 1.1 echo ">>> version.h compiled successfully."
524     }
525    
526 vapier 1.153 unpack_2_6() {
527     # this file is required for other things to build properly, so we
528 johnm 1.172 # autogenerate it ... generate a .config to keep version.h build from
529 vapier 1.153 # spitting out an annoying warning
530 johnm 1.177 make -s mrproper ${xmakeopts} 2>/dev/null \
531     || die "make mrproper failed"
532    
533     # quick fix for bug #132152 which triggers when it cannot include linux
534     # headers (ie, we have not installed it yet)
535 vapier 1.188 if ! make -s defconfig ${xmakeopts} &>/dev/null 2>&1 ; then
536 johnm 1.177 touch .config
537     eerror "make defconfig failed."
538     eerror "assuming you dont have any headers installed yet and continuing"
539     epause 5
540     fi
541    
542     make -s include/linux/version.h ${xmakeopts} 2>/dev/null \
543     || die "make include/linux/version.h failed"
544 swegener 1.179 rm -f .config >/dev/null
545 vapier 1.153 }
546    
547 johnm 1.1 universal_unpack() {
548 mpagano 1.254 debug-print "Inside universal_unpack"
549    
550 vapier 1.266 local OKV_ARRAY
551     IFS="." read -r -a OKV_ARRAY <<<"${OKV}"
552 mpagano 1.254
553 mpagano 1.223 cd "${WORKDIR}"
554 mpagano 1.254 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
555 tomwij 1.279 unpack linux-${KV_MAJOR}.${KV_MINOR}.tar.xz
556 mpagano 1.254 else
557 tomwij 1.279 unpack linux-${OKV}.tar.xz
558 mpagano 1.254 fi
559    
560 johnm 1.175 if [[ -d "linux" ]]; then
561 mpagano 1.254 debug-print "Moving linux to linux-${KV_FULL}"
562 johnm 1.175 mv linux linux-${KV_FULL} \
563     || die "Unable to move source tree to ${KV_FULL}."
564     elif [[ "${OKV}" != "${KV_FULL}" ]]; then
565 mpagano 1.254 if [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]] &&
566     [[ "${ETYPE}" = "sources" ]]; then
567     debug-print "moving linux-${KV_MAJOR}.${KV_MINOR} to linux-${KV_FULL} "
568     mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
569     || die "Unable to move source tree to ${KV_FULL}."
570     else
571     debug-print "moving linux-${OKV} to linux-${KV_FULL} "
572     mv linux-${OKV} linux-${KV_FULL} \
573     || die "Unable to move source tree to ${KV_FULL}."
574     fi
575     elif [[ ${#OKV_ARRAY[@]} -ge 3 ]] && [[ ${KV_MAJOR} -ge 3 ]]; then
576     mv linux-${KV_MAJOR}.${KV_MINOR} linux-${KV_FULL} \
577 johnm 1.55 || die "Unable to move source tree to ${KV_FULL}."
578 hollow 1.98 fi
579 vapier 1.136 cd "${S}"
580 lu_zero 1.62
581 johnm 1.1 # remove all backup files
582     find . -iname "*~" -exec rm {} \; 2> /dev/null
583    
584     }
585    
586     unpack_set_extraversion() {
587 vapier 1.136 cd "${S}"
588 dsd 1.104 sed -i -e "s:^\(EXTRAVERSION =\).*:\1 ${EXTRAVERSION}:" Makefile
589 vapier 1.185 cd "${OLDPWD}"
590 johnm 1.1 }
591    
592 dsd 1.104 # Should be done after patches have been applied
593     # Otherwise patches that modify the same area of Makefile will fail
594     unpack_fix_install_path() {
595 vapier 1.136 cd "${S}"
596 dsd 1.104 sed -i -e 's:#export\tINSTALL_PATH:export\tINSTALL_PATH:' Makefile
597     }
598    
599 johnm 1.1 # Compile Functions
600     #==============================================================
601     compile_headers() {
602 vapier 1.153 env_setup_xmakeopts
603    
604 swegener 1.135 # if we couldnt obtain HOSTCFLAGS from the Makefile,
605 vapier 1.75 # then set it to something sane
606 vapier 1.136 local HOSTCFLAGS=$(getfilevar HOSTCFLAGS "${S}"/Makefile)
607 vapier 1.75 HOSTCFLAGS=${HOSTCFLAGS:--Wall -Wstrict-prototypes -O2 -fomit-frame-pointer}
608    
609 johnm 1.93 if kernel_is 2 4; then
610 vapier 1.75 yes "" | make oldconfig ${xmakeopts}
611 johnm 1.72 echo ">>> make oldconfig complete"
612 vapier 1.152 make dep ${xmakeopts}
613 hollow 1.95 elif kernel_is 2 6; then
614 vapier 1.193 # 2.6.18 introduces headers_install which means we dont need any
615     # of this crap anymore :D
616     kernel_is ge 2 6 18 && return 0
617    
618 johnm 1.72 # autoconf.h isnt generated unless it already exists. plus, we have
619     # no guarantee that any headers are installed on the system...
620 vapier 1.75 [[ -f ${ROOT}/usr/include/linux/autoconf.h ]] \
621 johnm 1.72 || touch include/linux/autoconf.h
622    
623 plasmaroo 1.105 # if K_DEFCONFIG isn't set, force to "defconfig"
624     # needed by mips
625     if [[ -z ${K_DEFCONFIG} ]]; then
626 dostrow 1.194 if [[ $(KV_to_int ${KV}) -ge $(KV_to_int 2.6.16) ]]; then
627     case ${CTARGET} in
628     powerpc64*) K_DEFCONFIG="ppc64_defconfig";;
629     powerpc*) K_DEFCONFIG="pmac32_defconfig";;
630     *) K_DEFCONFIG="defconfig";;
631     esac
632     else
633     K_DEFCONFIG="defconfig"
634     fi
635 plasmaroo 1.105 fi
636    
637 johnm 1.72 # if there arent any installed headers, then there also isnt an asm
638     # symlink in /usr/include/, and make defconfig will fail, so we have
639     # to force an include path with $S.
640 vapier 1.75 HOSTCFLAGS="${HOSTCFLAGS} -I${S}/include/"
641     ln -sf asm-${KARCH} "${S}"/include/asm
642 vapier 1.153 cross_pre_c_headers && return 0
643    
644 vapier 1.170 make ${K_DEFCONFIG} HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "defconfig failed (${K_DEFCONFIG})"
645     if compile_headers_tweak_config ; then
646     yes "" | make oldconfig HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "2nd oldconfig failed"
647     fi
648 vapier 1.75 make prepare HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
649 eradicator 1.100 make prepare-all HOSTCFLAGS="${HOSTCFLAGS}" ${xmakeopts} || die "prepare failed"
650 johnm 1.72 fi
651 johnm 1.1 }
652    
653 vapier 1.170 compile_headers_tweak_config() {
654     # some targets can be very very picky, so let's finesse the
655     # .config based upon any info we may have
656     case ${CTARGET} in
657     sh*)
658     sed -i '/CONFIG_CPU_SH/d' .config
659     echo "CONFIG_CPU_SH${CTARGET:2:1}=y" >> .config
660     return 0;;
661     esac
662    
663     # no changes, so lets do nothing
664     return 1
665     }
666    
667 johnm 1.1 # install functions
668     #==============================================================
669     install_universal() {
670 tomwij 1.281 # Fix silly permissions in tarball
671 mpagano 1.223 cd "${WORKDIR}"
672 tomwij 1.281 chown -R 0:0 * >& /dev/null
673 johnm 1.1 chmod -R a+r-w+X,u+w *
674 johnm 1.93 cd ${OLDPWD}
675 johnm 1.1 }
676    
677     install_headers() {
678 vapier 1.195 local ddir=$(kernel_header_destdir)
679    
680 vapier 1.193 # 2.6.18 introduces headers_install which means we dont need any
681     # of this crap anymore :D
682     if kernel_is ge 2 6 18 ; then
683     env_setup_xmakeopts
684 vapier 1.195 emake headers_install INSTALL_HDR_PATH="${D}"/${ddir}/.. ${xmakeopts} || die
685 vapier 1.196
686     # let other packages install some of these headers
687     rm -rf "${D}"/${ddir}/sound #alsa-headers
688     rm -rf "${D}"/${ddir}/scsi #glibc/uclibc/etc...
689 vapier 1.193 return 0
690     fi
691    
692 vapier 1.198 # Do not use "linux/*" as that can cause problems with very long
693     # $S values where the cmdline to cp is too long
694 vapier 1.245 pushd "${S}" >/dev/null
695 vapier 1.60 dodir ${ddir}/linux
696 vapier 1.198 cp -pPR "${S}"/include/linux "${D}"/${ddir}/ || die
697     rm -rf "${D}"/${ddir}/linux/modules
698 lu_zero 1.62
699 vapier 1.245 dodir ${ddir}/asm
700     cp -pPR "${S}"/include/asm/* "${D}"/${ddir}/asm
701 vapier 1.137
702 vapier 1.245 if kernel_is 2 6 ; then
703 vapier 1.60 dodir ${ddir}/asm-generic
704 mpagano 1.223 cp -pPR "${S}"/include/asm-generic/* "${D}"/${ddir}/asm-generic
705 johnm 1.12 fi
706 eradicator 1.99
707 vapier 1.103 # clean up
708     find "${D}" -name '*.orig' -exec rm -f {} \;
709    
710 vapier 1.245 popd >/dev/null
711 johnm 1.1 }
712    
713     install_sources() {
714 dsd 1.183 local file
715 johnm 1.1
716 vapier 1.136 cd "${S}"
717 johnm 1.12 dodir /usr/src
718 johnm 1.54 echo ">>> Copying sources ..."
719 johnm 1.93
720 johnm 1.27 file="$(find ${WORKDIR} -iname "docs" -type d)"
721 johnm 1.93 if [[ -n ${file} ]]; then
722     for file in $(find ${file} -type f); do
723 vapier 1.136 echo "${file//*docs\/}" >> "${S}"/patches.txt
724     echo "===================================================" >> "${S}"/patches.txt
725     cat ${file} >> "${S}"/patches.txt
726     echo "===================================================" >> "${S}"/patches.txt
727     echo "" >> "${S}"/patches.txt
728 johnm 1.1 done
729 johnm 1.12 fi
730 johnm 1.1
731 johnm 1.93 if [[ ! -f ${S}/patches.txt ]]; then
732 johnm 1.12 # patches.txt is empty so lets use our ChangeLog
733 johnm 1.93 [[ -f ${FILESDIR}/../ChangeLog ]] && \
734     echo "Please check the ebuild ChangeLog for more details." \
735 vapier 1.136 > "${S}"/patches.txt
736 johnm 1.12 fi
737    
738 mpagano 1.223 mv ${WORKDIR}/linux* "${D}"/usr/src
739 johnm 1.1 }
740    
741     # pkg_preinst functions
742     #==============================================================
743     preinst_headers() {
744 vapier 1.60 local ddir=$(kernel_header_destdir)
745 johnm 1.72 [[ -L ${ddir}/linux ]] && rm ${ddir}/linux
746     [[ -L ${ddir}/asm ]] && rm ${ddir}/asm
747 johnm 1.1 }
748    
749     # pkg_postinst functions
750     #==============================================================
751     postinst_sources() {
752 vapier 1.80 local MAKELINK=0
753 swegener 1.135
754 johnm 1.84 # if we have USE=symlink, then force K_SYMLINK=1
755     use symlink && K_SYMLINK=1
756    
757 robbat2 1.229 # if we're using a deblobbed kernel, it's not supported
758 robbat2 1.230 [[ $K_DEBLOB_AVAILABLE == 1 ]] && \
759 robbat2 1.229 use deblob && \
760 robbat2 1.232 K_SECURITY_UNSUPPORTED=deblob
761 robbat2 1.229
762 johnm 1.78 # if we are to forcably symlink, delete it if it already exists first.
763 johnm 1.166 if [[ ${K_SYMLINK} > 0 ]]; then
764 vapier 1.80 [[ -h ${ROOT}usr/src/linux ]] && rm ${ROOT}usr/src/linux
765 johnm 1.78 MAKELINK=1
766     fi
767 swegener 1.135
768 johnm 1.78 # if the link doesnt exist, lets create it
769 vapier 1.80 [[ ! -h ${ROOT}usr/src/linux ]] && MAKELINK=1
770 swegener 1.135
771 johnm 1.93 if [[ ${MAKELINK} == 1 ]]; then
772 mpagano 1.223 cd "${ROOT}"usr/src
773 johnm 1.89 ln -sf linux-${KV_FULL} linux
774     cd ${OLDPWD}
775     fi
776 johnm 1.1
777     # Don't forget to make directory for sysfs
778 johnm 1.111 [[ ! -d ${ROOT}sys ]] && kernel_is 2 6 && mkdir ${ROOT}sys
779 johnm 1.1
780     echo
781 zlin 1.208 elog "If you are upgrading from a previous kernel, you may be interested"
782 mpagano 1.213 elog "in the following document:"
783 zlin 1.208 elog " - General upgrade guide: http://www.gentoo.org/doc/en/kernel-upgrade.xml"
784 r3pek 1.113 echo
785 lu_zero 1.62
786 johnm 1.2 # if K_EXTRAEINFO is set then lets display it now
787 hollow 1.95 if [[ -n ${K_EXTRAEINFO} ]]; then
788 johnm 1.2 echo ${K_EXTRAEINFO} | fmt |
789 hollow 1.95 while read -s ELINE; do einfo "${ELINE}"; done
790 plasmaroo 1.33 fi
791    
792 zlin 1.208 # if K_EXTRAELOG is set then lets display it now
793     if [[ -n ${K_EXTRAELOG} ]]; then
794     echo ${K_EXTRAELOG} | fmt |
795     while read -s ELINE; do elog "${ELINE}"; done
796     fi
797    
798 iggy 1.7 # if K_EXTRAEWARN is set then lets display it now
799 hollow 1.95 if [[ -n ${K_EXTRAEWARN} ]]; then
800 iggy 1.7 echo ${K_EXTRAEWARN} | fmt |
801 hollow 1.95 while read -s ELINE; do ewarn "${ELINE}"; done
802 iggy 1.7 fi
803 dsd 1.200
804     # optionally display security unsupported message
805 robbat2 1.232 # Start with why
806     if [[ ${K_SECURITY_UNSUPPORTED} = deblob ]]; then
807 ulm 1.233 ewarn "Deblobbed kernels are UNSUPPORTED by Gentoo Security."
808 robbat2 1.232 elif [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
809     ewarn "${PN} is UNSUPPORTED by Gentoo Security."
810     fi
811     # And now the general message.
812 dsd 1.200 if [[ -n ${K_SECURITY_UNSUPPORTED} ]]; then
813     ewarn "This means that it is likely to be vulnerable to recent security issues."
814     ewarn "For specific information on why this kernel is unsupported, please read:"
815     ewarn "http://www.gentoo.org/proj/en/security/kernel.xml"
816     fi
817 bluebird 1.214
818     # warn sparc users that they need to do cross-compiling with >= 2.6.25(bug #214765)
819     KV_MAJOR=$(get_version_component_range 1 ${OKV})
820     KV_MINOR=$(get_version_component_range 2 ${OKV})
821     KV_PATCH=$(get_version_component_range 3 ${OKV})
822 mpagano 1.252 if [[ "$(tc-arch)" = "sparc" ]]; then
823     if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.24 ]]
824     then
825     echo
826     elog "NOTE: Since 2.6.25 the kernel Makefile has changed in a way that"
827     elog "you now need to do"
828     elog " make CROSS_COMPILE=sparc64-unknown-linux-gnu-"
829     elog "instead of just"
830     elog " make"
831     elog "to compile the kernel. For more information please browse to"
832     elog "https://bugs.gentoo.org/show_bug.cgi?id=214765"
833     echo
834     fi
835 bluebird 1.214 fi
836 johnm 1.1 }
837    
838 johnm 1.12 # pkg_setup functions
839     #==============================================================
840     setup_headers() {
841 vapier 1.86 [[ -z ${H_SUPPORTEDARCH} ]] && H_SUPPORTEDARCH=${PN/-*/}
842 hollow 1.95 for i in ${H_SUPPORTEDARCH}; do
843 vapier 1.87 [[ $(tc-arch) == "${i}" ]] && H_ACCEPT_ARCH="yes"
844 johnm 1.12 done
845 lu_zero 1.62
846 johnm 1.93 if [[ ${H_ACCEPT_ARCH} != "yes" ]]; then
847 johnm 1.12 echo
848 vapier 1.106 eerror "This version of ${PN} does not support $(tc-arch)."
849 johnm 1.12 eerror "Please merge the appropriate sources, in most cases"
850 vapier 1.106 eerror "(but not all) this will be called $(tc-arch)-headers."
851     die "Package unsupported for $(tc-arch)"
852 johnm 1.12 fi
853     }
854    
855 johnm 1.1 # unipatch
856     #==============================================================
857     unipatch() {
858 johnm 1.108 local i x y z extention PIPE_CMD UNIPATCH_DROP KPATCH_DIR PATCH_DEPTH ELINE
859 mpagano 1.238 local STRICT_COUNT PATCH_LEVEL myLC_ALL myLANG
860 swegener 1.135
861 johnm 1.78 # set to a standard locale to ensure sorts are ordered properly.
862     myLC_ALL="${LC_ALL}"
863 johnm 1.122 myLANG="${LANG}"
864 johnm 1.78 LC_ALL="C"
865 johnm 1.122 LANG=""
866 johnm 1.1
867     [ -z "${KPATCH_DIR}" ] && KPATCH_DIR="${WORKDIR}/patches/"
868     [ ! -d ${KPATCH_DIR} ] && mkdir -p ${KPATCH_DIR}
869    
870 johnm 1.41 # We're gonna need it when doing patches with a predefined patchlevel
871 mpagano 1.238 eshopts_push -s extglob
872 johnm 1.41
873 johnm 1.54 # This function will unpack all passed tarballs, add any passed patches, and remove any passed patchnumbers
874 johnm 1.1 # usage can be either via an env var or by params
875 johnm 1.54 # although due to the nature we pass this within this eclass
876     # it shall be by param only.
877     # -z "${UNIPATCH_LIST}" ] && UNIPATCH_LIST="${@}"
878     UNIPATCH_LIST="${@}"
879 johnm 1.1
880     #unpack any passed tarballs
881 hollow 1.95 for i in ${UNIPATCH_LIST}; do
882 vapier 1.210 if echo ${i} | grep -qs -e "\.tar" -e "\.tbz" -e "\.tgz" ; then
883 hollow 1.95 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
884 johnm 1.110 unset z
885 johnm 1.121 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
886 johnm 1.108 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
887     do z="${z}0";
888     done
889 r3pek 1.112 PATCH_ORDER="${z}${STRICT_COUNT}"
890 johnm 1.108
891 vapier 1.210 mkdir -p "${KPATCH_DIR}/${PATCH_ORDER}"
892     pushd "${KPATCH_DIR}/${PATCH_ORDER}" >/dev/null
893     unpack ${i##*/}
894     popd >/dev/null
895 johnm 1.16 else
896 vapier 1.210 pushd "${KPATCH_DIR}" >/dev/null
897     unpack ${i##*/}
898     popd >/dev/null
899 johnm 1.16 fi
900    
901 vapier 1.210 [[ ${i} == *:* ]] && echo ">>> Strict patch levels not currently supported for tarballed patchsets"
902 johnm 1.16 else
903 johnm 1.25 extention=${i/*./}
904 johnm 1.41 extention=${extention/:*/}
905 johnm 1.25 PIPE_CMD=""
906     case ${extention} in
907 vapier 1.236 xz) PIPE_CMD="xz -dc";;
908     lzma) PIPE_CMD="lzma -dc";;
909 johnm 1.25 bz2) PIPE_CMD="bzip2 -dc";;
910     patch) PIPE_CMD="cat";;
911     diff) PIPE_CMD="cat";;
912     gz|Z|z) PIPE_CMD="gzip -dc";;
913     ZIP|zip) PIPE_CMD="unzip -p";;
914 johnm 1.41 *) UNIPATCH_DROP="${UNIPATCH_DROP} ${i/:*/}";;
915 johnm 1.25 esac
916 johnm 1.41
917     PATCH_LEVEL=${i/*([^:])?(:)}
918     i=${i/:*/}
919 johnm 1.25 x=${i/*\//}
920     x=${x/\.${extention}/}
921 lu_zero 1.62
922 hollow 1.95 if [ -n "${PIPE_CMD}" ]; then
923     if [ ! -r "${i}" ]; then
924 johnm 1.29 echo
925     eerror "FATAL: unable to locate:"
926     eerror "${i}"
927 johnm 1.54 eerror "for read-only. The file either has incorrect permissions"
928     eerror "or does not exist."
929 johnm 1.29 die Unable to locate ${i}
930     fi
931 lu_zero 1.62
932 hollow 1.95 if [ -n "${UNIPATCH_STRICTORDER}" ]; then
933 johnm 1.110 unset z
934 johnm 1.121 STRICT_COUNT=$((10#${STRICT_COUNT} + 1))
935 johnm 1.108 for((y=0; y<$((6 - ${#STRICT_COUNT})); y++));
936     do z="${z}0";
937     done
938 r3pek 1.112 PATCH_ORDER="${z}${STRICT_COUNT}"
939 johnm 1.108
940 r3pek 1.112 mkdir -p ${KPATCH_DIR}/${PATCH_ORDER}/
941 scarabeus 1.241 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${PATCH_ORDER}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
942 johnm 1.29 else
943 scarabeus 1.241 $(${PIPE_CMD} ${i} > ${KPATCH_DIR}/${x}.patch${PATCH_LEVEL}) || die "uncompressing patch failed"
944 johnm 1.29 fi
945 johnm 1.25 fi
946 johnm 1.16 fi
947 johnm 1.1 done
948    
949     #populate KPATCH_DIRS so we know where to look to remove the excludes
950     x=${KPATCH_DIR}
951     KPATCH_DIR=""
952 hollow 1.95 for i in $(find ${x} -type d | sort -n); do
953 johnm 1.1 KPATCH_DIR="${KPATCH_DIR} ${i}"
954     done
955    
956 mpagano 1.219 # do not apply fbcondecor patch to sparc/sparc64 as it breaks boot
957     # bug #272676
958 maekke 1.220 if [[ "$(tc-arch)" = "sparc" || "$(tc-arch)" = "sparc64" ]]; then
959 mpagano 1.252 if [[ ${KV_MAJOR} -ge 3 || ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} > 2.6.28 ]]; then
960 mpagano 1.219 UNIPATCH_DROP="${UNIPATCH_DROP} *_fbcondecor-0.9.6.patch"
961     echo
962     ewarn "fbcondecor currently prevents sparc/sparc64 from booting"
963     ewarn "for kernel versions >= 2.6.29. Removing fbcondecor patch."
964     ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=272676 for details"
965     echo
966     fi
967     fi
968    
969 johnm 1.1 #so now lets get rid of the patchno's we want to exclude
970 johnm 1.19 UNIPATCH_DROP="${UNIPATCH_EXCLUDE} ${UNIPATCH_DROP}"
971 hollow 1.95 for i in ${UNIPATCH_DROP}; do
972 johnm 1.55 ebegin "Excluding Patch #${i}"
973 hollow 1.95 for x in ${KPATCH_DIR}; do rm -f ${x}/${i}* 2>/dev/null; done
974 johnm 1.55 eend $?
975 johnm 1.1 done
976    
977     # and now, finally, we patch it :)
978 hollow 1.95 for x in ${KPATCH_DIR}; do
979     for i in $(find ${x} -maxdepth 1 -iname "*.patch*" -or -iname "*.diff*" | sort -n); do
980 johnm 1.25 STDERR_T="${T}/${i/*\//}"
981 johnm 1.41 STDERR_T="${STDERR_T/.patch*/.err}"
982    
983 lu_zero 1.62 [ -z ${i/*.patch*/} ] && PATCH_DEPTH=${i/*.patch/}
984 r3pek 1.112 #[ -z ${i/*.diff*/} ] && PATCH_DEPTH=${i/*.diff/}
985 johnm 1.41
986 hollow 1.96 if [ -z "${PATCH_DEPTH}" ]; then PATCH_DEPTH=0; fi
987 johnm 1.41
988     ebegin "Applying ${i/*\//} (-p${PATCH_DEPTH}+)"
989 hollow 1.95 while [ ${PATCH_DEPTH} -lt 5 ]; do
990 plasmaroo 1.33 echo "Attempting Dry-run:" >> ${STDERR_T}
991 robbat2 1.204 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i}" >> ${STDERR_T}
992 johnm 1.54 echo "=======================================================" >> ${STDERR_T}
993 robbat2 1.204 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch --dry-run -f < ${i} >> ${STDERR_T}) $? -eq 0 ]; then
994 johnm 1.25 echo "Attempting patch:" > ${STDERR_T}
995 robbat2 1.204 echo "cmd: patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i}" >> ${STDERR_T}
996 johnm 1.54 echo "=======================================================" >> ${STDERR_T}
997 robbat2 1.204 if [ $(patch -p${PATCH_DEPTH} --no-backup-if-mismatch -f < ${i} >> ${STDERR_T}) "$?" -eq 0 ]; then
998 johnm 1.1 eend 0
999 johnm 1.25 rm ${STDERR_T}
1000 johnm 1.1 break
1001     else
1002     eend 1
1003     eerror "Failed to apply patch ${i/*\//}"
1004 johnm 1.54 eerror "Please attach ${STDERR_T} to any bug you may post."
1005 mpagano 1.238 eshopts_pop
1006 johnm 1.1 die "Failed to apply ${i/*\//}"
1007     fi
1008     else
1009     PATCH_DEPTH=$((${PATCH_DEPTH} + 1))
1010     fi
1011     done
1012 hollow 1.95 if [ ${PATCH_DEPTH} -eq 5 ]; then
1013 johnm 1.1 eend 1
1014 johnm 1.54 eerror "Please attach ${STDERR_T} to any bug you may post."
1015 mpagano 1.238 eshopts_pop
1016 johnm 1.1 die "Unable to dry-run patch."
1017     fi
1018     done
1019     done
1020 johnm 1.43
1021 johnm 1.144 # This is a quick, and kind of nasty hack to deal with UNIPATCH_DOCS which
1022     # sit in KPATCH_DIR's. This is handled properly in the unipatch rewrite,
1023     # which is why I'm not taking too much time over this.
1024     local tmp
1025     for i in ${UNIPATCH_DOCS}; do
1026     tmp="${tmp} ${i//*\/}"
1027 mpagano 1.223 cp -f ${i} "${T}"/
1028 johnm 1.144 done
1029     UNIPATCH_DOCS="${tmp}"
1030 swegener 1.146
1031 johnm 1.43 # clean up KPATCH_DIR's - fixes bug #53610
1032 hollow 1.95 for x in ${KPATCH_DIR}; do rm -Rf ${x}; done
1033 swegener 1.135
1034 johnm 1.78 LC_ALL="${myLC_ALL}"
1035 johnm 1.122 LANG="${myLANG}"
1036 mpagano 1.238 eshopts_pop
1037 johnm 1.1 }
1038    
1039 johnm 1.74 # getfilevar accepts 2 vars as follows:
1040     # getfilevar <VARIABLE> <CONFIGFILE>
1041     # pulled from linux-info
1042    
1043     getfilevar() {
1044 johnm 1.93 local workingdir basefname basedname xarch=$(tc-arch-kernel)
1045 johnm 1.74
1046 johnm 1.93 if [[ -z ${1} ]] && [[ ! -f ${2} ]]; then
1047 johnm 1.74 echo -e "\n"
1048     eerror "getfilevar requires 2 variables, with the second a valid file."
1049     eerror " getfilevar <VARIABLE> <CONFIGFILE>"
1050     else
1051     workingdir=${PWD}
1052     basefname=$(basename ${2})
1053     basedname=$(dirname ${2})
1054     unset ARCH
1055 swegener 1.135
1056 johnm 1.74 cd ${basedname}
1057     echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \
1058 johnm 1.119 make ${BUILD_FIXES} -s -f - e 2>/dev/null
1059 johnm 1.74 cd ${workingdir}
1060 swegener 1.135
1061 johnm 1.74 ARCH=${xarch}
1062     fi
1063     }
1064    
1065 johnm 1.28 detect_arch() {
1066     # This function sets ARCH_URI and ARCH_PATCH
1067     # with the neccessary info for the arch sepecific compatibility
1068     # patchsets.
1069 lu_zero 1.62
1070 johnm 1.93 local ALL_ARCH LOOP_ARCH COMPAT_URI i
1071 plasmaroo 1.33
1072     # COMPAT_URI is the contents of ${ARCH}_URI
1073     # ARCH_URI is the URI for all the ${ARCH}_URI patches
1074     # ARCH_PATCH is ARCH_URI broken into files for UNIPATCH
1075    
1076     ARCH_URI=""
1077     ARCH_PATCH=""
1078 vapier 1.145 ALL_ARCH="ALPHA AMD64 ARM HPPA IA64 M68K MIPS PPC PPC64 S390 SH SPARC X86"
1079 johnm 1.31
1080 hollow 1.95 for LOOP_ARCH in ${ALL_ARCH}; do
1081 johnm 1.31 COMPAT_URI="${LOOP_ARCH}_URI"
1082     COMPAT_URI="${!COMPAT_URI}"
1083 lu_zero 1.62
1084 vapier 1.86 [[ -n ${COMPAT_URI} ]] && \
1085 johnm 1.55 ARCH_URI="${ARCH_URI} $(echo ${LOOP_ARCH} | tr '[:upper:]' '[:lower:]')? ( ${COMPAT_URI} )"
1086 lu_zero 1.62
1087 johnm 1.93 if [[ ${LOOP_ARCH} == "$(echo $(tc-arch-kernel) | tr '[:lower:]' '[:upper:]')" ]]; then
1088     for i in ${COMPAT_URI}; do
1089 plasmaroo 1.33 ARCH_PATCH="${ARCH_PATCH} ${DISTDIR}/${i/*\//}"
1090     done
1091     fi
1092 johnm 1.31 done
1093 johnm 1.28 }
1094    
1095 johnm 1.89 headers___fix() {
1096 plasmaroo 1.88 # Voodoo to partially fix broken upstream headers.
1097 vapier 1.205 # note: do not put inline/asm/volatile together (breaks "inline asm volatile")
1098 johnm 1.72 sed -i \
1099 plasmaroo 1.186 -e '/^\#define.*_TYPES_H/{:loop n; bloop}' \
1100 plasmaroo 1.184 -e 's:\<\([us]\(8\|16\|32\|64\)\)\>:__\1:g' \
1101 vapier 1.205 -e "s/\([[:space:]]\)inline\([[:space:](]\)/\1__inline__\2/g" \
1102     -e "s/\([[:space:]]\)asm\([[:space:](]\)/\1__asm__\2/g" \
1103     -e "s/\([[:space:]]\)volatile\([[:space:](]\)/\1__volatile__\2/g" \
1104 johnm 1.72 "$@"
1105     }
1106 johnm 1.28
1107 johnm 1.1 # common functions
1108     #==============================================================
1109 plasmaroo 1.33 kernel-2_src_unpack() {
1110 johnm 1.1 universal_unpack
1111 robbat2 1.163 debug-print "Doing unipatch"
1112 lu_zero 1.62
1113 dsd 1.126 [[ -n ${UNIPATCH_LIST} || -n ${UNIPATCH_LIST_DEFAULT} || -n ${UNIPATCH_LIST_GENPATCHES} ]] && \
1114     unipatch "${UNIPATCH_LIST_DEFAULT} ${UNIPATCH_LIST_GENPATCHES} ${UNIPATCH_LIST}"
1115 swegener 1.165
1116 robbat2 1.163 debug-print "Doing premake"
1117 lu_zero 1.62
1118 vapier 1.157 # allow ebuilds to massage the source tree after patching but before
1119     # we run misc `make` functions below
1120 vapier 1.158 [[ $(type -t kernel-2_hook_premake) == "function" ]] && kernel-2_hook_premake
1121 swegener 1.165
1122 mpagano 1.224 debug-print "Doing epatch_user"
1123     epatch_user
1124    
1125 robbat2 1.163 debug-print "Doing unpack_set_extraversion"
1126 vapier 1.157
1127 johnm 1.107 [[ -z ${K_NOSETEXTRAVERSION} ]] && unpack_set_extraversion
1128 dsd 1.104 unpack_fix_install_path
1129    
1130 johnm 1.172 # Setup xmakeopts and cd into sourcetree.
1131     env_setup_xmakeopts
1132     cd "${S}"
1133    
1134     # We dont need a version.h for anything other than headers
1135     # at least, I should hope we dont. If this causes problems
1136     # take out the if/fi block and inform me please.
1137     # unpack_2_6 should now be 2.6.17 safe anyways
1138     if [[ ${ETYPE} == headers ]]; then
1139     kernel_is 2 4 && unpack_2_4
1140     kernel_is 2 6 && unpack_2_6
1141     fi
1142 robbat2 1.229
1143 robbat2 1.230 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1144 robbat2 1.239 cp "${DISTDIR}/${DEBLOB_A}" "${T}" || die "cp ${DEBLOB_A} failed"
1145     cp "${DISTDIR}/${DEBLOB_CHECK_A}" "${T}/deblob-check" || die "cp ${DEBLOB_CHECK_A} failed"
1146     chmod +x "${T}/${DEBLOB_A}" "${T}/deblob-check" || die "chmod deblob scripts failed"
1147 robbat2 1.229 fi
1148 mpagano 1.276
1149     # fix a problem on ppc where TOUT writes to /usr/src/linux breaking sandbox
1150     # only do this for kernel < 2.6.27 since this file does not exist in later
1151     # kernels
1152     if [[ -n ${KV_MINOR} && ${KV_MAJOR}.${KV_MINOR}.${KV_PATCH} < 2.6.27 ]]
1153     then
1154     sed -i \
1155     -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
1156     "${S}"/arch/ppc/Makefile
1157     else
1158     sed -i \
1159     -e 's|TOUT := .tmp_gas_check|TOUT := $(T).tmp_gas_check|' \
1160     "${S}"/arch/powerpc/Makefile
1161     fi
1162 johnm 1.1 }
1163    
1164 plasmaroo 1.33 kernel-2_src_compile() {
1165 vapier 1.136 cd "${S}"
1166 johnm 1.93 [[ ${ETYPE} == headers ]] && compile_headers
1167 robbat2 1.229
1168 robbat2 1.230 if [[ $K_DEBLOB_AVAILABLE == 1 ]] && use deblob ; then
1169 robbat2 1.229 echo ">>> Running deblob script ..."
1170 mpagano 1.278 EPYTHON="python2" sh "${T}/${DEBLOB_A}" --force || die "Deblob script failed to run!!!"
1171 robbat2 1.229 fi
1172 johnm 1.1 }
1173    
1174 robbat2 1.240 # if you leave it to the default src_test, it will run make to
1175     # find whether test/check targets are present; since "make test"
1176     # actually produces a few support files, they are installed even
1177     # though the package is binchecks-restricted.
1178     #
1179     # Avoid this altogether by making the function moot.
1180     kernel-2_src_test() { :; }
1181    
1182 plasmaroo 1.33 kernel-2_pkg_preinst() {
1183 johnm 1.93 [[ ${ETYPE} == headers ]] && preinst_headers
1184 johnm 1.1 }
1185    
1186 plasmaroo 1.33 kernel-2_src_install() {
1187 johnm 1.1 install_universal
1188 johnm 1.93 [[ ${ETYPE} == headers ]] && install_headers
1189     [[ ${ETYPE} == sources ]] && install_sources
1190 johnm 1.1 }
1191    
1192 plasmaroo 1.33 kernel-2_pkg_postinst() {
1193 johnm 1.93 [[ ${ETYPE} == sources ]] && postinst_sources
1194 johnm 1.1 }
1195 johnm 1.12
1196 plasmaroo 1.33 kernel-2_pkg_setup() {
1197 phreak 1.192 if kernel_is 2 4; then
1198 vapier 1.264 if [[ $(gcc-major-version) -ge 4 ]] ; then
1199 phreak 1.192 echo
1200     ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with linux-2.4!"
1201     ewarn "Either switch to another gcc-version (via gcc-config) or use a"
1202     ewarn "newer kernel that supports gcc-4."
1203     echo
1204     ewarn "Also be aware that bugreports about gcc-4 not working"
1205     ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
1206     echo
1207     epause 10
1208     fi
1209     fi
1210    
1211 blubb 1.167 ABI="${KERNEL_ABI}"
1212 johnm 1.93 [[ ${ETYPE} == headers ]] && setup_headers
1213     [[ ${ETYPE} == sources ]] && echo ">>> Preparing to unpack ..."
1214 johnm 1.12 }
1215 mpagano 1.256
1216     kernel-2_pkg_postrm() {
1217 vapier 1.263 # This warning only makes sense for kernel sources.
1218     [[ ${ETYPE} == headers ]] && return 0
1219 vapier 1.271
1220     # If there isn't anything left behind, then don't complain.
1221     [[ -e ${ROOT}usr/src/linux-${KV_FULL} ]] || return 0
1222 mpagano 1.256 echo
1223     ewarn "Note: Even though you have successfully unmerged "
1224     ewarn "your kernel package, directories in kernel source location: "
1225     ewarn "${ROOT}usr/src/linux-${KV_FULL}"
1226     ewarn "with modified files will remain behind. By design, package managers"
1227     ewarn "will not remove these modified files and the directories they reside in."
1228     echo
1229     }

  ViewVC Help
Powered by ViewVC 1.1.20